// Code generated by BobGen psql v0.22.0. DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package factory

import (
	"context"
	"strings"

	"github.com/aarondl/opt/null"
	"github.com/jaswdr/faker"
	models "github/epith/302-backend-user/bob"
)

type Factory struct {
	baseAnimeMods AnimeModSlice
	baseGenreMods GenreModSlice
}

func New() *Factory {
	return &Factory{}
}

func (f *Factory) NewAnime(mods ...AnimeMod) *AnimeTemplate {
	o := &AnimeTemplate{f: f}

	if f != nil {
		f.baseAnimeMods.Apply(o)
	}

	AnimeModSlice(mods).Apply(o)

	return o
}

func (f *Factory) NewGenre(mods ...GenreMod) *GenreTemplate {
	o := &GenreTemplate{f: f}

	if f != nil {
		f.baseGenreMods.Apply(o)
	}

	GenreModSlice(mods).Apply(o)

	return o
}

func (f *Factory) ClearBaseAnimeMods() {
	f.baseAnimeMods = nil
}

func (f *Factory) AddBaseAnimeMod(mods ...AnimeMod) {
	f.baseAnimeMods = append(f.baseAnimeMods, mods...)
}

func (f *Factory) ClearBaseGenreMods() {
	f.baseGenreMods = nil
}

func (f *Factory) AddBaseGenreMod(mods ...GenreMod) {
	f.baseGenreMods = append(f.baseGenreMods, mods...)
}

type contextKey string

var (
	animeCtx = newContextual[*models.Anime]("anime")
	genreCtx = newContextual[*models.Genre]("genre")
)

type contextual[V any] struct {
	key contextKey
}

// This could be weird because of type inference not handling `K` due to `V` having to be manual.
func newContextual[V any](key string) contextual[V] {
	return contextual[V]{key: contextKey(key)}
}

func (k contextual[V]) WithValue(ctx context.Context, val V) context.Context {
	return context.WithValue(ctx, k.key, val)
}

func (k contextual[V]) Value(ctx context.Context) (V, bool) {
	v, ok := ctx.Value(k.key).(V)
	return v, ok
}

var defaultFaker = faker.New()

// random returns a random value for the given type, using the faker
// * If the given faker is nil, the default faker is used
// * The zero value is returned if the type cannot be handled
func random[T any](f *faker.Faker) T {
	if f == nil {
		f = &defaultFaker
	}

	var val T
	switch any(val).(type) {
	default:
		return val
	case string:
		return any(string(strings.Join(f.Lorem().Words(5), " "))).(T)

	case bool:
		return any(bool(f.BoolWithChance(50))).(T)

	case int:
		return any(int(f.Int())).(T)

	}
}

// randomNull is like [Random], but for null types
func randomNull[T any](f *faker.Faker) null.Val[T] {
	return null.From(random[T](f))
}
